Bug 731946 - btrfs panic under aio stress
Summary: btrfs panic under aio stress
Keywords:
Status: CLOSED DUPLICATE of bug 698324
Alias: None
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: kernel
Version: 6.2
Hardware: x86_64
OS: Linux
unspecified
medium
Target Milestone: rc
: ---
Assignee: Josef Bacik
QA Contact: Red Hat Kernel QE team
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2011-08-19 08:16 UTC by Eryu Guan
Modified: 2012-06-07 14:23 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2012-06-07 14:23:47 UTC


Attachments (Terms of Use)

Description Eryu Guan 2011-08-19 08:16:01 UTC
Description of problem:
btrfs panic under aio stress from ltp(aio-stress)

btrfs csum failed ino 259 off 126976 csum 1721289657 private 4008681878 
btrfs csum failed ino 259 off 28672 csum 342202583 private 2815362281 
........lots of similar outputs..........
btrfs csum failed ino 259 off 61440 csum 3662794319 private 1454447525 
btrfs csum failed ino 259 off 94208 csum 538532013 private 2156913174 
btrfs csum failed ino 259 off 159744 csum 2775044119 private 854976528 
------------[ cut here ]------------ 
WARNING: at fs/btrfs/file.c:371 btrfs_drop_extents+0x369/0xa20 [btrfs]() (Tainted: G           ---------------- T) 
Hardware name: hp workstation xw4200 
Modules linked in: btrfs(T) zlib_deflate lzo_decompress lzo_compress libcrc32c sunrpc p4_clockmod freq_table speedstep_lib ipv6 ppdev parport_pc parport microcode serio_raw sg iTCO_wdt iTCO_vendor_support snd_intel8x0 snd_ac97_codec ac97_bus snd_seq snd_seq_device snd_pcm snd_timer snd soundcore snd_page_alloc tg3 ext3 jbd mbcache sr_mod cdrom sd_mod crc_t10dif pata_acpi ata_generic ata_piix ahci nouveau ttm drm_kms_helper drm i2c_algo_bit i2c_core mxm_wmi wmi video output dm_mirror dm_region_hash dm_log dm_mod [last unloaded: mperf] 
Pid: 6575, comm: aio-stress Tainted: G           ---------------- T 2.6.32-188.el6.x86_64 #1 
Call Trace: 
 [<ffffffff810698e7>] ? warn_slowpath_common+0x87/0xc0 
 [<ffffffff8106993a>] ? warn_slowpath_null+0x1a/0x20 
 [<ffffffffa04d54d9>] ? btrfs_drop_extents+0x369/0xa20 [btrfs] 
 [<ffffffffa04c604c>] ? start_transaction+0x1cc/0x270 [btrfs] 
 [<ffffffffa04d223f>] ? btrfs_cont_expand+0x1cf/0x2c0 [btrfs] 
 [<ffffffffa04d3bcb>] ? prepare_pages+0x6b/0x3b0 [btrfs] 
 [<ffffffffa04b0dc7>] ? btrfs_delalloc_reserve_metadata+0x147/0x180 [btrfs] 
 [<ffffffffa04d4576>] ? btrfs_file_aio_write+0x666/0x9d0 [btrfs] 
 [<ffffffff81127991>] ? lru_cache_add_lru+0x21/0x40 
 [<ffffffff8113ff3a>] ? vma_merge+0x1ba/0x3b0 
 [<ffffffffa04d3f10>] ? btrfs_file_aio_write+0x0/0x9d0 [btrfs] 
 [<ffffffff811bbe64>] ? aio_rw_vect_retry+0x84/0x200 
 [<ffffffff811bdeb4>] ? aio_run_iocb+0x64/0x170 
 [<ffffffff811beaa5>] ? do_io_submit+0x2d5/0x980 
 [<ffffffff811bf160>] ? sys_io_submit+0x10/0x20 
 [<ffffffff8100b0b2>] ? system_call_fastpath+0x16/0x1b 
---[ end trace 2cf3264b3787e5e8 ]--- 
------------[ cut here ]------------ 
kernel BUG at fs/btrfs/inode.c:3597! 
invalid opcode: 0000 [#1] SMP  
last sysfs file: /sys/devices/pci0000:00/0000:00:1f.2/host0/target0:0:0/0:0:0:0/block/sda/dev 
CPU 0  
Modules linked in: btrfs(T) zlib_deflate lzo_decompress lzo_compress libcrc32c sunrpc p4_clockmod freq_table speedstep_lib ipv6 ppdev parport_pc parport microcode serio_raw sg iTCO_wdt iTCO_vendor_support snd_intel8x0 snd_ac97_codec ac97_bus snd_seq snd_seq_device snd_pcm snd_timer snd soundcore snd_page_alloc tg3 ext3 jbd mbcache sr_mod cdrom sd_mod crc_t10dif pata_acpi ata_generic ata_piix ahci nouveau ttm drm_kms_helper drm i2c_algo_bit i2c_core mxm_wmi wmi video output dm_mirror dm_region_hash dm_log dm_mod [last unloaded: mperf] 
 
Pid: 6575, comm: aio-stress Tainted: G        W  ---------------- T 2.6.32-188.el6.x86_64 #1 Hewlett-Packard hp workstation xw4200/0914h 
RIP: 0010:[<ffffffffa04d230e>]  [<ffffffffa04d230e>] btrfs_cont_expand+0x29e/0x2c0 [btrfs] 
RSP: 0018:ffff88001a8cbb08  EFLAGS: 00010282 
RAX: 00000000ffffffef RBX: ffff8800054b87c0 RCX: ffff88001a8ca000 
RDX: 000000000000000d RSI: ffff88001a6507f0 RDI: 0000000000000282 
RBP: ffff88001a8cbbc8 R08: 0000000000000001 R09: 0000000000000001 
R10: 0000000000000000 R11: ffff88001a4b0f20 R12: 000000003a533000 
R13: ffff88001b82f1d8 R14: 0000000035c67000 R15: 000000003a533000 
FS:  00007f9ebe264700(0000) GS:ffff880002200000(0000) knlGS:0000000000000000 
CS:  0010 DS: 0000 ES: 0000 CR0: 000000008005003b 
CR2: 00007f9ebd92fad0 CR3: 000000000702c000 CR4: 00000000000006f0 
DR0: 0000000000000000 DR1: 0000000000000000 DR2: 0000000000000000 
DR3: 0000000000000000 DR6: 00000000ffff0ff0 DR7: 0000000000000400 
Process aio-stress (pid: 6575, threadinfo ffff88001a8ca000, task ffff88001f7c6a80) 
Stack: 
 00000000048cc000 0000000000000000 00000000048cc000 ffff880000000000 
<0> ffff880000000000 ffff880000000000 ffff880007ed6e80 00000000048cc000 
<0> 000000003a532fff ffff88001b82f070 ffff88001b82f040 fffffffffffff000 
Call Trace: 
 [<ffffffffa04d3bcb>] prepare_pages+0x6b/0x3b0 [btrfs] 
 [<ffffffffa04b0dc7>] ? btrfs_delalloc_reserve_metadata+0x147/0x180 [btrfs] 
 [<ffffffffa04d4576>] btrfs_file_aio_write+0x666/0x9d0 [btrfs] 
 [<ffffffff81127991>] ? lru_cache_add_lru+0x21/0x40 
 [<ffffffff8113ff3a>] ? vma_merge+0x1ba/0x3b0 
 [<ffffffffa04d3f10>] ? btrfs_file_aio_write+0x0/0x9d0 [btrfs] 
 [<ffffffff811bbe64>] aio_rw_vect_retry+0x84/0x200 
 [<ffffffff811bdeb4>] aio_run_iocb+0x64/0x170 
 [<ffffffff811beaa5>] do_io_submit+0x2d5/0x980 
 [<ffffffff811bf160>] sys_io_submit+0x10/0x20 
 [<ffffffff8100b0b2>] system_call_fastpath+0x16/0x1b 
Code: 48 8d 4d c8 41 b8 50 00 00 00 4c 89 ee e8 5b 5d 01 00 48 81 c4 98 00 00 00 44 89 f0 5b 41 5c 41 5d 41 5e 41 5f c9 c3 0f 0b eb fe <0f> 0b eb fe 0f 0b eb fe 4c 8b 6d a0 41 89 c6 0f 1f 00 eb b1 66  
RIP  [<ffffffffa04d230e>] btrfs_cont_expand+0x29e/0x2c0 [btrfs] 
 RSP <ffff88001a8cbb08> 
---[ end trace 2cf3264b3787e5e9 ]--- 
Kernel panic - not syncing: Fatal exception 
Pid: 6575, comm: aio-stress Tainted: G      D W  ---------------- T 2.6.32-188.el6.x86_64 #1 
Call Trace: 
 [<ffffffff814ea395>] ? panic+0x78/0x143 
 [<ffffffff814ee534>] ? oops_end+0xe4/0x100 
 [<ffffffff8100f22b>] ? die+0x5b/0x90 
 [<ffffffff814ede04>] ? do_trap+0xc4/0x160 
 [<ffffffff8100cdf5>] ? do_invalid_op+0x95/0xb0 
 [<ffffffffa04d230e>] ? btrfs_cont_expand+0x29e/0x2c0 [btrfs] 
 [<ffffffffa04ac65d>] ? btrfs_insert_empty_items+0x8d/0xf0 [btrfs] 
 [<ffffffff814eb470>] ? _cond_resched+0x30/0x40 
 [<ffffffff8100be9b>] ? invalid_op+0x1b/0x20 
 [<ffffffffa04d230e>] ? btrfs_cont_expand+0x29e/0x2c0 [btrfs] 
 [<ffffffffa04d2292>] ? btrfs_cont_expand+0x222/0x2c0 [btrfs] 
 [<ffffffffa04d3bcb>] ? prepare_pages+0x6b/0x3b0 [btrfs] 
 [<ffffffffa04b0dc7>] ? btrfs_delalloc_reserve_metadata+0x147/0x180 [btrfs] 
 [<ffffffffa04d4576>] ? btrfs_file_aio_write+0x666/0x9d0 [btrfs] 
 [<ffffffff81127991>] ? lru_cache_add_lru+0x21/0x40 
 [<ffffffff8113ff3a>] ? vma_merge+0x1ba/0x3b0 
 [<ffffffffa04d3f10>] ? btrfs_file_aio_write+0x0/0x9d0 [btrfs] 
 [<ffffffff811bbe64>] ? aio_rw_vect_retry+0x84/0x200 
 [<ffffffff811bdeb4>] ? aio_run_iocb+0x64/0x170 
 [<ffffffff811beaa5>] ? do_io_submit+0x2d5/0x980 
 [<ffffffff811bf160>] ? sys_io_submit+0x10/0x20 
 [<ffffffff8100b0b2>] ? system_call_fastpath+0x16/0x1b 
panic occurred, switching back to text console 

Version-Release number of selected component (if applicable):
kernel-2.6.32-188.el6

How reproducible:
Not every time 1/2 for now

Steps to Reproduce:
1. yum install rh-tests-kernel-filesystems-ltp-aiodio
2. cd /mnt/tests/kernel/filesystems/ltp-aiodio
3. FSTYP=btrfs SCRATCH_DEV=/dev/sda5 make run
  
Actual results:
kernel panic

Expected results:
test pass

Additional info:
Beaker job:
https://beaker.engineering.redhat.com/jobs/121873
log:
http://lab2.rhts.eng.bos.redhat.com/beaker/logs/recipes/250743//console.log

Comment 2 RHEL Product and Program Management 2011-10-07 15:45:14 UTC
Since RHEL 6.2 External Beta has begun, and this bug remains
unresolved, it has been rejected as it is not proposed as
exception or blocker.

Red Hat invites you to ask your support representative to
propose this request, if appropriate and relevant, in the
next release of Red Hat Enterprise Linux.

Comment 3 Josef Bacik 2012-06-07 14:23:47 UTC

*** This bug has been marked as a duplicate of bug 698324 ***


Note You need to log in before you can comment on or make changes to this bug.